clear all
close all
format short g
time=300;
%rng(35)

%% video initialization
vd = VideoWriter('test_video', 'MPEG-4');
frm=1;


%% ARENA
x = linspace(0.0,4.0,100);
y = zeros(length(x),1);
fig=figure('Name', 'VIRTUAL FLY', 'Position', [100 200 1920 600]); %max: 1920-1080
arena_builder;

ax = gca;
h = hgtransform('Parent',ax);
%hold on
plot(x(1),y(1),'o','LineWidth', 20, 'color', 'k','MarkerFaceColor', 'k', 'Parent',h);
%hold off

%starting point and translation
c1=ones(time,1);
c2=ones(time,1);
c1(1)=1+floor(10*(rand(1)-0.5)/3)/10;
c2(1)=1+floor(10*(rand(1)-0.5)/3)/10;
%display coordinates of the fly
t6 = text(-.1,-.1,0, ['coordinates: %', num2str([c1(1) c2(1)])], 'VerticalAlignment','top','FontSize',14);

direction=ones(time,1);
face=zeros(time,4);
face(1,:)=[1 0 0 0];
position=zeros(time,16);
vision=zeros(time,4);

subplot(2,3,[2 3])
colormap(bone)
axis([0 time -0.1 16.1])
title('Where in the arena')

subplot(2,3,5)
%cue=animatedline('LineWidth', 2.5);
axis([0 time 0 5])
title('Perceived cue')

subplot(2,3,6)
%bod= animatedline('LineWidth', 2.5);
axis([0 time 0 5])
title('Body orientation')

for k = 2:time
    %action seleztion
    if floor(k/5)==k/5
        disp(k);
        direction(k)=randi(3,1);
    else
        direction(k)=1;
    end

    behaviour_control
    [c1, c2]=arena_border(c1, c2, k);
    
    position=position_control(position, c1, c2, k);
    
    vision=vision_control(vision, position, face, k);
    
    m1 = makehgtform('translate',c1(k),c2(k),0);
    h.Matrix = m1;
    t1;
    t6.String = num2str([c1(k) c2(k)]);

    %addpoints(bod,k,face(k));
    %addpoints(cue,k,vision(k));

    subplot(2,3,[2 3])
    imagesc(position')
    title('Where in the arena')    
    
    subplot(2,3,5)
    imagesc(vision')
    title('Perceived cue')
    
    subplot(2,3,6)
    imagesc(face')
    title('Body orientation')
       
    drawnow
    wait(1)
    
    %frame capture
    mvm(frm) = getframe(fig);
    frm=frm+1;
end

%% video recording
open(vd)
writeVideo(vd,mvm)
close(vd)

%sources
%https://www.mathworks.com/help/matlab/ref/animatedline.html
%https://www.mathworks.com/help/matlab/creating_plots/move-group-of-objects-along-line.html